<?php

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class Af_Wc_Daps_Ajax_Controller {

	public function __construct() {
		add_action( 'wp_ajax_af_wc_daps_add_fee_on_checkout_page', array( $this, 'af_wc_daps_add_fee_on_checkout_page' ) );

		add_action( 'wp_ajax_nopriv_af_wc_daps_add_fee_on_checkout_page', array( $this, 'af_wc_daps_add_fee_on_checkout_page' ) );

		add_action( 'wp_ajax_af_wc_daps_show_time_slot', array( $this, 'af_wc_daps_show_time_slot' ) );

		add_action( 'wp_ajax_nopriv_af_wc_daps_show_time_slot', array( $this, 'af_wc_daps_show_time_slot' ) );

		add_action( 'wp_ajax_af_wc_daps_show_time_slot_checkout_page', array( $this, 'af_wc_daps_show_time_slot_checkout_page' ) );

		add_action( 'wp_ajax_nopriv_af_wc_daps_show_time_slot_checkout_page', array( $this, 'af_wc_daps_show_time_slot_checkout_page' ) );
	}


	public function af_wc_daps_add_fee_on_checkout_page() {
		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : '';
		if ( isset( $_POST['nonce'] ) && ! wp_verify_nonce( $nonce, 'af-wc-daps-ajax-nonce' ) ) {
			wp_die( esc_html__( 'Failed security check!', 'ka-order-delivery-date-and-time-scheduler' ) );
		}

		if (isset($_POST['af_wc_daps_fee_data'])) {
			$af_wc_daps_fee_data = sanitize_meta('', wp_unslash($_POST['af_wc_daps_fee_data']), '');
		} else {
			$af_wc_daps_fee_data = array();
		}


		if ( '' == $af_wc_daps_fee_data['af_wc_daps_day_fee'] ) {
			$af_wc_daps_day_old_fee = floatval( WC()->session->get( 'af_wc_daps_day_fee' ) );
			WC()->session->set( 'af_wc_daps_day_fee', $af_wc_daps_day_old_fee );
		} else {
			WC()->session->set( 'af_wc_daps_day_fee', $af_wc_daps_fee_data['af_wc_daps_day_fee'] );
		}

		if ( '' == $af_wc_daps_fee_data['af_wc_daps_time_slot_fee'] ) {
			$af_wc_daps_time_slot_old_fee = floatval( WC()->session->get( 'af_wc_daps_time_slot_fee' ) );
			WC()->session->set( 'af_wc_daps_time_slot_fee', $af_wc_daps_time_slot_old_fee );
		} else {
			WC()->session->set( 'af_wc_daps_time_slot_fee', $af_wc_daps_fee_data['af_wc_daps_time_slot_fee'] );
		}

		add_action('woocommerce_blocks_loaded', function () {
			woocommerce_store_api_register_update_callback(
				array(
					'namespace' => 'extension-unique-namespace',
					'callback'  => function () {
					},
				)
			);
		} );

		$response = array(
			'message' => 'Fee added Successfully!',
		);
		wp_send_json_success( $response );
		die();
	}


	public function af_wc_daps_show_time_slot() {

		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : '';
		if ( isset( $_POST['nonce'] ) && ! wp_verify_nonce( $nonce, 'af-wc-daps-ajax-nonce' ) ) {
			wp_die( esc_html__( 'Failed security check!', 'ka-order-delivery-date-and-time-scheduler' ) );
		}

		if ( isset( $_POST['af_wc_daps_selected_day'] ) ) {
			$af_wc_daps_selected_day = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_selected_day'])  );
		} else {
			$af_wc_daps_selected_day = '';
		}

		if ( isset( $_POST['af_wc_daps_selected_date'] ) ) {
			$af_wc_daps_selected_date = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_selected_date'])  );
		} else {
			$af_wc_daps_selected_date = '';
		}

		if ( isset( $_POST['af_wc_daps_rule_id'] ) ) {
			$af_wc_daps_rule_id = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_rule_id'])  );
		} else {
			$af_wc_daps_rule_id = '';
		}

		if ( isset( $_POST['af_wc_daps_time_slot_type'] ) ) {
			$af_wc_daps_time_slot_type = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_time_slot_type'])  );
		} else {
			$af_wc_daps_time_slot_type = '';
		}

		$time_zone_settings = get_option('af_wc_daps_timezone_settings');

		$is_default_time_zone = isset( $time_zone_settings['af_wc_daps_use_default_timezone'] ) ?  $time_zone_settings['af_wc_daps_use_default_timezone']  : '';
		$buffer_time          = isset( $time_zone_settings['af_wc_daps_buffer_time'] ) && '' != $time_zone_settings['af_wc_daps_buffer_time']?  $time_zone_settings['af_wc_daps_buffer_time']  : '180';


		$time_zone = '';

		if ('' == $is_default_time_zone) {
			$time_zone = isset( $time_zone_settings['af_wc_daps_timezone'] ) ? $time_zone_settings['af_wc_daps_timezone']  : '';
		} else {
			$time_zone = wp_timezone_string();
		}

		$current_time = af_wc_daps_get_current_time($time_zone);
		$current_date = af_wc_daps_get_current_date($time_zone);


		$current_time_obj     = DateTime::createFromFormat('H:i:s', $current_time);
		$buffer_time_interval = new DateInterval('PT' . $buffer_time . 'M');
		$current_time_obj->add($buffer_time_interval);

		if ('time_slot' == $af_wc_daps_time_slot_type) {
			$af_wc_daps_time_slot_setting = (array) get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_slot_settings', true);

			$af_wc_daps_time_slot_per_order_details = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_slot_per_order_details', true); 

			$af_wc_daps_applicable_time_slots = array();


			foreach ($af_wc_daps_time_slot_setting as $key=>$af_wc_daps_time_slot) {
				if (( !isset($af_wc_daps_time_slot['days_of_week']) || in_array($af_wc_daps_selected_day, $af_wc_daps_time_slot['days_of_week']) ) ) {

					$slot_start_time_obj = DateTime::createFromFormat('h:i a', $af_wc_daps_time_slot['start_time']);

					if ($af_wc_daps_selected_date == $current_date && $slot_start_time_obj <= $current_time_obj) {
						continue;
					}

					if ('' != $af_wc_daps_time_slot['orders_per_slot']) {
						if (!empty($af_wc_daps_time_slot_per_order_details) && in_array($af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key, array_keys($af_wc_daps_time_slot_per_order_details))) {
							if ($af_wc_daps_time_slot_per_order_details[ $af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key ]<=0) {
								continue;
							}
						}
					}
					
					$af_wc_daps_time_slot_charges        = ! empty( $af_wc_daps_time_slot['charges'] ) ? get_woocommerce_currency_symbol() . $af_wc_daps_time_slot['charges'] : 'Free';
					$af_wc_daps_time_slot_value          = $key . '_' . $af_wc_daps_time_slot['start_time'] . '-' . $af_wc_daps_time_slot['end_time'] . ' ( ' . $af_wc_daps_time_slot_charges . ' ) ';
					$af_wc_daps_time_slot_title          = $af_wc_daps_time_slot['start_time'] . '-' . $af_wc_daps_time_slot['end_time'] . ' ( ' . $af_wc_daps_time_slot_charges . ' ) ';
					$af_wc_daps_applicable_time_slots [] = array(
						'value' => $af_wc_daps_time_slot_value,
						'text'  => $af_wc_daps_time_slot_title,
					);
				}
			}

			$response = array(
				'message'                          => 'Time slots fethched sucessfully',
				'type'                             => $af_wc_daps_time_slot_type,
				'af_wc_daps_applicable_time_slots' => $af_wc_daps_applicable_time_slots,
			);
		} elseif ('time_select' == $af_wc_daps_time_slot_type) {

			$af_wc_daps_time_slot_setting = (array) get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_slot_settings', true);

			$af_wc_daps_time_slot_per_order_details = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_select_slot_per_order_details', true);  

			$af_wc_daps_applicable_time_slots = array();

			$af_wc_daps_rule_setting = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_rule_settings', true);

			$af_wc_daps_start_time          = $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_start_time']? $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_start_time']:'';
			$af_wc_daps_end_time            = $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_end_time']? $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_end_time']:'';
			$af_wc_daps_time_slot_duration  = $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_slot_duration'] && '' != $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_slot_duration']? $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_slot_duration']:'30';
			$af_wc_daps_time_slot_remaining = $af_wc_daps_rule_setting['orders_per_slot'] && '' != $af_wc_daps_rule_setting['orders_per_slot']? $af_wc_daps_rule_setting['orders_per_slot']:'';

		
			$start_timestamp    = strtotime($af_wc_daps_start_time);
			$end_timestamp      = strtotime($af_wc_daps_end_time);
			$time_slot_duration = $af_wc_daps_time_slot_duration * 60; 
			
			if ($end_timestamp <= $start_timestamp) {
				$end_timestamp += 24 * 60 * 60;
			}

			if ('' != $af_wc_daps_start_time && '' != $af_wc_daps_end_time ) {
				$key = 0;
				while ($start_timestamp + $time_slot_duration <= $end_timestamp) {
					$slotStart = gmdate('h:i a', $start_timestamp);
					$slotEnd   = gmdate('h:i a', $start_timestamp + $time_slot_duration);
					
					$start_timestamp += $time_slot_duration;
										
					$af_wc_daps_applicable_time_slots [] = array(
						'value'      => $key . '_' . $slotStart . ' - ' . $slotEnd,
						'text'       => $slotStart . ' - ' . $slotEnd,
						'slot_start' => $slotStart,
					);
					++$key;
				}
			}   
			// if ('' != $af_wc_daps_time_slot_remaining) {
			foreach ($af_wc_daps_applicable_time_slots as $key => $values) {
				$slot_start_time_obj = DateTime::createFromFormat('h:i a', $values['slot_start']);

				if ($af_wc_daps_selected_date == $current_date && $slot_start_time_obj <= $current_time_obj) {
					unset($af_wc_daps_applicable_time_slots[ $key ]);
				}

				if ('' != $af_wc_daps_time_slot_remaining && !empty($af_wc_daps_time_slot_per_order_details) && in_array($af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key, array_keys($af_wc_daps_time_slot_per_order_details))) {
					if ($af_wc_daps_time_slot_per_order_details[ $af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key ]<=0) {
						unset($af_wc_daps_applicable_time_slots[ $key ]);
					}
				}
			}
			// }

			$response = array(
				'message'                          =>  'Time slots created sucessfully',
				'type'                             =>  $af_wc_daps_time_slot_type,
				'af_wc_daps_applicable_time_slots' =>  $af_wc_daps_applicable_time_slots,
			);
		}


		wp_send_json_success( $response );
		die();
	}

	public function af_wc_daps_show_time_slot_checkout_page() {

		
		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : '';
		if ( isset( $_POST['nonce'] ) && ! wp_verify_nonce( $nonce, 'af-wc-daps-ajax-nonce' ) ) {
			wp_die( esc_html__( 'Failed security check!', 'ka-order-delivery-date-and-time-scheduler' ) );
		}

		if ( isset( $_POST['af_wc_daps_selected_day'] ) ) {
			$af_wc_daps_selected_day = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_selected_day'])  );
		} else {
			$af_wc_daps_selected_day = '';
		}

		if ( isset( $_POST['af_wc_daps_selected_date'] ) ) {
			$af_wc_daps_selected_date = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_selected_date'])  );
		} else {
			$af_wc_daps_selected_date = '';
		}

		if ( isset( $_POST['af_wc_daps_rule_id'] ) ) {
			$af_wc_daps_rule_id = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_rule_id'])  );
		} else {
			$af_wc_daps_rule_id = '';
		}

		if ( isset( $_POST['af_wc_daps_time_slot_type'] ) ) {
			$af_wc_daps_time_slot_type = sanitize_text_field( wp_unslash( $_POST['af_wc_daps_time_slot_type'])  );
		} else {
			$af_wc_daps_time_slot_type = '';
		}

		$time_zone_settings = get_option('af_wc_daps_timezone_settings');

		$is_default_time_zone = isset( $time_zone_settings['af_wc_daps_use_default_timezone'] ) ?  $time_zone_settings['af_wc_daps_use_default_timezone']  : '';
		$buffer_time          = isset( $time_zone_settings['af_wc_daps_buffer_time'] ) && '' != $time_zone_settings['af_wc_daps_buffer_time']?  $time_zone_settings['af_wc_daps_buffer_time']  : '180';


		$time_zone = '';

		if ('' == $is_default_time_zone) {
			$time_zone = isset( $time_zone_settings['af_wc_daps_timezone'] ) ? $time_zone_settings['af_wc_daps_timezone']  : '';
		} else {
			$time_zone = wp_timezone_string();
		}

		$current_time = af_wc_daps_get_current_time($time_zone);
		$current_date = af_wc_daps_get_current_date($time_zone);

		$current_time_obj     = DateTime::createFromFormat('H:i:s', $current_time);
		$buffer_time_interval = new DateInterval('PT' . $buffer_time . 'M');
		$current_time_obj->add($buffer_time_interval);

		if ('time_slot' == $af_wc_daps_time_slot_type) {

			$af_wc_daps_time_slot_setting = (array) get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_slot_settings', true);

			$af_wc_daps_applicable_time_slots = array();

			$af_wc_daps_time_slot_per_order_details = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_slot_per_order_details', true); 


			foreach ($af_wc_daps_time_slot_setting as $key => $af_wc_daps_time_slot) {
				if (!isset($af_wc_daps_time_slot['days_of_week']) || in_array($af_wc_daps_selected_day, $af_wc_daps_time_slot['days_of_week'])) {
					
					$slot_start_time_obj = DateTime::createFromFormat('h:i a', $af_wc_daps_time_slot['start_time']);

					if ($af_wc_daps_selected_date == $current_date && $slot_start_time_obj <= $current_time_obj) {
						continue;
					}

					if ('' != $af_wc_daps_time_slot['orders_per_slot']) {
						if (!empty($af_wc_daps_time_slot_per_order_details) && in_array($af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key, array_keys($af_wc_daps_time_slot_per_order_details))) {
							if ($af_wc_daps_time_slot_per_order_details[ $af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key ]<=0) {
								continue;
							}
						}
					}
					
					$af_wc_daps_time_slot_charges = ! empty( $af_wc_daps_time_slot['charges'] ) ? get_woocommerce_currency_symbol() . $af_wc_daps_time_slot['charges'] : 'Free';
					$af_wc_daps_time_slot_title   = $af_wc_daps_time_slot['start_time'] . '-' . $af_wc_daps_time_slot['end_time'] . ' ( ' . $af_wc_daps_time_slot_charges . ' ) ';
					$af_wc_daps_time_slot_value   = $key . '_' . $af_wc_daps_time_slot['start_time'] . '-' . $af_wc_daps_time_slot['end_time'] . ' ( ' . $af_wc_daps_time_slot_charges . ' ) ';


					$af_wc_daps_applicable_time_slots [] = array(
						'value' => $af_wc_daps_time_slot_value,
						'text'  => $af_wc_daps_time_slot_title,
					);
				}
			}
			

			$response = array(
				'message'                          => 'Time slots fethched sucessfully',
				'type'                             => $af_wc_daps_time_slot_type,
				'af_wc_daps_applicable_time_slots' =>$af_wc_daps_applicable_time_slots,
			);
		} elseif ('time_select' == $af_wc_daps_time_slot_type) {

			
			$af_wc_daps_time_slot_setting = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_slot_settings', true);

			$af_wc_daps_time_slot_per_order_details = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_time_select_slot_per_order_details', true);
			
			$af_wc_daps_applicable_time_slots = array();

			$af_wc_daps_rule_setting = get_post_meta($af_wc_daps_rule_id, 'af_wc_daps_rule_settings', true);

			$af_wc_daps_start_time          = $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_start_time']? $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_start_time']:'';
			$af_wc_daps_end_time            = $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_end_time']? $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_end_time']:'';
			$af_wc_daps_time_slot_duration  = $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_slot_duration'] && '' != $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_slot_duration']? $af_wc_daps_rule_setting['af_wc_daps_rule_time_selector_slot_duration']:'30';
			$af_wc_daps_time_slot_remaining = $af_wc_daps_rule_setting['orders_per_slot'] && '' != $af_wc_daps_rule_setting['orders_per_slot']? $af_wc_daps_rule_setting['orders_per_slot']:'';

		
			$start_timestamp    = strtotime($af_wc_daps_start_time);
			$end_timestamp      = strtotime($af_wc_daps_end_time);
			$time_slot_duration = $af_wc_daps_time_slot_duration * 60; 
			
			if ($end_timestamp <= $start_timestamp) {
				$end_timestamp += 24 * 60 * 60;
			}

			if ('' != $af_wc_daps_start_time && '' != $af_wc_daps_end_time ) {
				$key = 0;
				while ($start_timestamp + $time_slot_duration <= $end_timestamp) {
					$slotStart = gmdate('h:i a', $start_timestamp);
					$slotEnd   = gmdate('h:i a', $start_timestamp + $time_slot_duration);
					
					$start_timestamp += $time_slot_duration;
										
					$af_wc_daps_applicable_time_slots [] = array(
						'value'      => $key . '_' . $slotStart . ' - ' . $slotEnd,
						'text'       => $slotStart . ' - ' . $slotEnd,
						'slot_start' => $slotStart,
					);
					++$key;
				}
			}   

			// if ('' != $af_wc_daps_time_slot_remaining) {
			foreach ($af_wc_daps_applicable_time_slots as $key => $values) {

				$slot_start_time_obj = DateTime::createFromFormat('h:i a', $values['slot_start']);

				if ($af_wc_daps_selected_date == $current_date && $slot_start_time_obj <= $current_time_obj) {
					unset($af_wc_daps_applicable_time_slots[ $key ]);
				}

				if ('' != $af_wc_daps_time_slot_remaining && !empty($af_wc_daps_time_slot_per_order_details) && in_array($af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key, array_keys($af_wc_daps_time_slot_per_order_details))) {
					if ($af_wc_daps_time_slot_per_order_details[ $af_wc_daps_selected_date . '_' . $af_wc_daps_rule_id . '_' . $key ]<=0) {
						unset($af_wc_daps_applicable_time_slots[ $key ]);
					}
				}
			}
			// }

			
			$response = array(
				'message'                          =>  'Time slots created sucessfully',
				'type'                             =>  $af_wc_daps_time_slot_type,
				'af_wc_daps_applicable_time_slots' =>  $af_wc_daps_applicable_time_slots,
			);


		}

		


		wp_send_json_success( $response );
		die();
	}
}

new Af_Wc_Daps_Ajax_Controller();
